Package: org.apache.groovy.parser.antlr4

## [Java] Class AstBuilder

- org.apache.groovy.parser.antlr4.AstBuilder

-     public class AstBuilder
      extends GroovyParserBaseVisitor

  Builds the AST from the parse tree generated by Antlr4.

- - ### Constructor Summary

    Constructors
    Constructor and description
    `AstBuilder (SourceUnit sourceUnit, boolean groovydocEnabled, boolean runtimeGroovydocEnabled)`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `BlockStatement` | `appendStatementsToBlockStatement(BlockStatement bs, Statement statements)`
    `` | `ModuleNode` | `buildAST()`
    `` | `void` | `syntaxError(Recognizer recognizer, Object offendingSymbol, int line, int charPositionInLine, String msg, RecognitionException e)`
    `` | `Object` | `visit(ParseTree tree)` Visit tree safely, no NPE occurred when the tree is null.
    `` | `BinaryExpression` | `visitAdditiveExprAlt(AdditiveExprAltContext ctx)`
    `` | `BinaryExpression` | `visitAndExprAlt(AndExprAltContext ctx)`
    `` | `ClassNode` | `visitAnnotatedQualifiedClassName(AnnotatedQualifiedClassNameContext ctx)`
    `` | `AnnotationNode` | `visitAnnotation(AnnotationContext ctx)`
    `` | `String` | `visitAnnotationName(AnnotationNameContext ctx)`
    `` | `List<AnnotationNode>` | `visitAnnotationsOpt(AnnotationsOptContext ctx)`
    `` | `InnerClassNode` | `visitAnonymousInnerClassDeclaration(AnonymousInnerClassDeclarationContext ctx)`
    `` | `Expression` | `visitArguments(ArgumentsContext ctx)`
    `` | `List<Expression>` | `visitArrayInitializer(ArrayInitializerContext ctx)`
    `` | `AssertStatement` | `visitAssertStatement(AssertStatementContext ctx)`
    `` | `BinaryExpression` | `visitAssignmentExprAlt(AssignmentExprAltContext ctx)`
    `` | `Statement` | `visitBlock(BlockContext ctx)`
    `` | `Statement` | `visitBlockStatement(BlockStatementContext ctx)`
    `` | `BlockStatement` | `visitBlockStatements(BlockStatementsContext ctx)`
    `` | `BlockStatement` | `visitBlockStatementsOpt(BlockStatementsOptContext ctx)`
    `` | `ConstantExpression` | `visitBooleanLiteralAlt(BooleanLiteralAltContext ctx)`
    `` | `BreakStatement` | `visitBreakStatement(BreakStatementContext ctx)`
    `` | `VariableExpression` | `visitBuiltInType(BuiltInTypeContext ctx)`
    `` | `CastExpression` | `visitCastExprAlt(CastExprAltContext ctx)`
    `` | `ClassNode` | `visitCastParExpression(CastParExpressionContext ctx)`
    `` | `List<CatchStatement>` | `visitCatchClause(CatchClauseContext ctx)` Multi-catch(1..*) clause will be unpacked to several normal catch clauses, so the return type is List
    `` | `List<ClassNode>` | `visitCatchType(CatchTypeContext ctx)`
    `` | `Void` | `visitClassBody(ClassBodyContext ctx)`
    `` | `Void` | `visitClassBodyDeclaration(ClassBodyDeclarationContext ctx)`
    `` | `ClassNode` | `visitClassDeclaration(ClassDeclarationContext ctx)`
    `` | `String` | `visitClassName(ClassNameContext ctx)`
    `` | `ModifierNode` | `visitClassOrInterfaceModifier(ClassOrInterfaceModifierContext ctx)`
    `` | `List<ModifierNode>` | `visitClassOrInterfaceModifiers(ClassOrInterfaceModifiersContext ctx)`
    `` | `List<ModifierNode>` | `visitClassOrInterfaceModifiersOpt(ClassOrInterfaceModifiersOptContext ctx)`
    `` | `ClassNode` | `visitClassOrInterfaceType(ClassOrInterfaceTypeContext ctx)`
    `` | `Tuple2<Parameter, Expression>` | `visitClassicalForControl(ClassicalForControlContext ctx)`
    `` | `ClosureExpression` | `visitClosure(ClosureContext ctx)`
    `` | `ClosureExpression` | `visitClosureOrLambdaExpression(ClosureOrLambdaExpressionContext ctx)`
    `` | `Expression` | `visitCommandArgument(CommandArgumentContext ctx)`
    `` | `ExpressionStatement` | `visitCommandExprAlt(CommandExprAltContext ctx)`
    `` | `Expression` | `visitCommandExpression(CommandExpressionContext ctx)`
    `` | `ModuleNode` | `visitCompilationUnit(CompilationUnitContext ctx)`
    `` | `Expression` | `visitConditionalExprAlt(ConditionalExprAltContext ctx)`
    `` | `Statement` | `visitConditionalStatement(ConditionalStatementContext ctx)`
    `` | `ContinueStatement` | `visitContinueStatement(ContinueStatementContext ctx)`
    `` | `ClassNode` | `visitCreatedName(CreatedNameContext ctx)`
    `` | `Expression` | `visitCreator(CreatorContext ctx)`
    `` | `Tuple3<Expression, List<AnnotationNode>, TerminalNode>` | `visitDim(DimContext ctx)`
    `` | `DoWhileStatement` | `visitDoWhileStmtAlt(DoWhileStmtAltContext ctx)`
    `` | `Expression` | `visitDynamicMemberName(DynamicMemberNameContext ctx)`
    `` | `Expression` | `visitElementValue(ElementValueContext ctx)`
    `` | `ListExpression` | `visitElementValueArrayInitializer(ElementValueArrayInitializerContext ctx)`
    `` | `Tuple2<String, Expression>` | `visitElementValuePair(ElementValuePairContext ctx)`
    `` | `Map<String, Expression>` | `visitElementValuePairs(ElementValuePairsContext ctx)`
    `` | `List<Tuple2<String, Expression>>` | `visitElementValues(ElementValuesContext ctx)`
    `` | `List<List<AnnotationNode>>` | `visitEmptyDims(EmptyDimsContext ctx)`
    `` | `List<List<AnnotationNode>>` | `visitEmptyDimsOpt(EmptyDimsOptContext ctx)`
    `` | `Expression` | `visitEnhancedArgumentListElement(EnhancedArgumentListElementContext ctx)`
    `` | `Expression` | `visitEnhancedArgumentListInPar(EnhancedArgumentListInParContext ctx)`
    `` | `Tuple2<Parameter, Expression>` | `visitEnhancedForControl(EnhancedForControlContext ctx)`
    `` | `Expression` | `visitEnhancedStatementExpression(EnhancedStatementExpressionContext ctx)`
    `` | `FieldNode` | `visitEnumConstant(EnumConstantContext ctx)`
    `` | `List<FieldNode>` | `visitEnumConstants(EnumConstantsContext ctx)`
    `` | `BinaryExpression` | `visitEqualityExprAlt(EqualityExprAltContext ctx)`
    `` | `BinaryExpression` | `visitExclusiveOrExprAlt(ExclusiveOrExprAltContext ctx)`
    `` | `Expression` | `visitExpressionInPar(ExpressionInParContext ctx)`
    `` | `List<Expression>` | `visitExpressionList(ExpressionListContext ctx)`
    `` | `Expression` | `visitExpressionListElement(ExpressionListElementContext ctx)`
    `` | `Void` | `visitFieldDeclaration(FieldDeclarationContext ctx)`
    `` | `Statement` | `visitFinallyBlock(FinallyBlockContext ctx)`
    `` | `ConstantExpression` | `visitFloatingPointLiteralAlt(FloatingPointLiteralAltContext ctx)`
    `` | `Tuple2<Parameter, Expression>` | `visitForControl(ForControlContext ctx)`
    `` | `Expression` | `visitForInit(ForInitContext ctx)`
    `` | `ForStatement` | `visitForStmtAlt(ForStmtAltContext ctx)`
    `` | `Expression` | `visitForUpdate(ForUpdateContext ctx)`
    `` | `Parameter` | `visitFormalParameter(FormalParameterContext ctx)`
    `` | `Parameter[]` | `visitFormalParameterList(FormalParameterListContext ctx)`
    `` | `Parameter[]` | `visitFormalParameters(FormalParametersContext ctx)`
    `` | `GStringExpression` | `visitGstring(GstringContext ctx)`
    `` | `Expression` | `visitGstringPath(GstringPathContext ctx)`
    `` | `Expression` | `visitGstringValue(GstringValueContext ctx)`
    `` | `String` | `visitIdentifier(IdentifierContext ctx)`
    `` | `Expression` | `visitIdentifierPrmrAlt(IdentifierPrmrAltContext ctx)`
    `` | `IfStatement` | `visitIfElseStatement(IfElseStatementContext ctx)`
    `` | `ImportNode` | `visitImportDeclaration(ImportDeclarationContext ctx)`
    `` | `BinaryExpression` | `visitInclusiveOrExprAlt(InclusiveOrExprAltContext ctx)`
    `` | `Tuple2<Token, Expression>` | `visitIndexPropertyArgs(IndexPropertyArgsContext ctx)`
    `` | `ConstantExpression` | `visitIntegerLiteralAlt(IntegerLiteralAltContext ctx)`
    `` | `ConstantExpression` | `visitKeywords(KeywordsContext ctx)`
    `` | `Statement` | `visitLabeledStmtAlt(LabeledStmtAltContext ctx)`
    `` | `Statement` | `visitLambdaBody(LambdaBodyContext ctx)`
    `` | `ListExpression` | `visitList(ListContext ctx)`
    `` | `AstBuilder.DeclarationListStatement` | `visitLocalVariableDeclaration(LocalVariableDeclarationContext ctx)`
    `` | `BinaryExpression` | `visitLogicalAndExprAlt(LogicalAndExprAltContext ctx)`
    `` | `BinaryExpression` | `visitLogicalOrExprAlt(LogicalOrExprAltContext ctx)`
    `` | `Statement` | `visitLoopStmtAlt(LoopStmtAltContext ctx)`
    `` | `MapExpression` | `visitMap(MapContext ctx)`
    `` | `MapEntryExpression` | `visitMapEntry(MapEntryContext ctx)`
    `` | `Expression` | `visitMapEntryLabel(MapEntryLabelContext ctx)`
    `` | `List<MapEntryExpression>` | `visitMapEntryList(MapEntryListContext ctx)`
    `` | `Void` | `visitMemberDeclaration(MemberDeclarationContext ctx)`
    `` | `Statement` | `visitMethodBody(MethodBodyContext ctx)`
    `` | `MethodNode` | `visitMethodDeclaration(MethodDeclarationContext ctx)`
    `` | `String` | `visitMethodName(MethodNameContext ctx)`
    `` | `ModifierNode` | `visitModifier(ModifierContext ctx)`
    `` | `List<ModifierNode>` | `visitModifiers(ModifiersContext ctx)`
    `` | `List<ModifierNode>` | `visitModifiersOpt(ModifiersOptContext ctx)`
    `` | `BinaryExpression` | `visitMultipleAssignmentExprAlt(MultipleAssignmentExprAltContext ctx)`
    `` | `BinaryExpression` | `visitMultiplicativeExprAlt(MultiplicativeExprAltContext ctx)`
    `` | `Expression` | `visitNamePart(NamePartContext ctx)`
    `` | `List<MapEntryExpression>` | `visitNamedPropertyArgs(NamedPropertyArgsContext ctx)`
    `` | `Expression` | `visitNewPrmrAlt(NewPrmrAltContext ctx)`
    `` | `GenericsType[]` | `visitNonWildcardTypeArguments(NonWildcardTypeArgumentsContext ctx)`
    `` | `ConstantExpression` | `visitNullLiteralAlt(NullLiteralAltContext ctx)`
    `` | `PackageNode` | `visitPackageDeclaration(PackageDeclarationContext ctx)`
    `` | `Expression` | `visitParExpression(ParExpressionContext ctx)`
    `` | `Expression` | `visitPathElement(PathElementContext ctx)`
    `` | `Expression` | `visitPathExpression(PathExpressionContext ctx)`
    `` | `Expression` | `visitPostfixExpression(PostfixExpressionContext ctx)`
    `` | `BinaryExpression` | `visitPowerExprAlt(PowerExprAltContext ctx)`
    `` | `ClassNode` | `visitPrimitiveType(PrimitiveTypeContext ctx)`
    `` | `ClassNode` | `visitQualifiedClassName(QualifiedClassNameContext ctx)`
    `` | `ClassNode[]` | `visitQualifiedClassNameList(QualifiedClassNameListContext ctx)`
    `` | `String` | `visitQualifiedName(QualifiedNameContext ctx)`
    `` | `ClassNode` | `visitQualifiedStandardClassName(QualifiedStandardClassNameContext ctx)`
    `` | `BinaryExpression` | `visitRegexExprAlt(RegexExprAltContext ctx)`
    `` | `Expression` | `visitRelationalExprAlt(RelationalExprAltContext ctx)`
    `` | `ExpressionStatement` | `visitResource(ResourceContext ctx)`
    `` | `List<ExpressionStatement>` | `visitResourceList(ResourceListContext ctx)`
    `` | `List<ExpressionStatement>` | `visitResources(ResourcesContext ctx)`
    `` | `ReturnStatement` | `visitReturnStmtAlt(ReturnStmtAltContext ctx)`
    `` | `ClassNode` | `visitReturnType(ReturnTypeContext ctx)`
    `` | `List<ASTNode>` | `visitScriptStatements(ScriptStatementsContext ctx)`
    `` | `Expression` | `visitShiftExprAlt(ShiftExprAltContext ctx)`
    `` | `LambdaExpression` | `visitStandardLambdaExpression(StandardLambdaExpressionContext ctx)`
    `` | `Parameter[]` | `visitStandardLambdaParameters(StandardLambdaParametersContext ctx)`
    `` | `ConstantExpression` | `visitStringLiteral(StringLiteralContext ctx)`
    `` | `VariableExpression` | `visitSuperPrmrAlt(SuperPrmrAltContext ctx)`
    `` | `List<Statement>` | `visitSwitchBlockStatementGroup(SwitchBlockStatementGroupContext ctx)`
    `` | `Tuple2<Token, Expression>` | `visitSwitchLabel(SwitchLabelContext ctx)`
    `` | `SwitchStatement` | `visitSwitchStatement(SwitchStatementContext ctx)`
    `` | `SynchronizedStatement` | `visitSynchronizedStmtAlt(SynchronizedStmtAltContext ctx)`
    `` | `Parameter` | `visitThisFormalParameter(ThisFormalParameterContext ctx)`
    `` | `VariableExpression` | `visitThisPrmrAlt(ThisPrmrAltContext ctx)`
    `` | `ThrowStatement` | `visitThrowStmtAlt(ThrowStmtAltContext ctx)`
    `` | `Statement` | `visitTryCatchStatement(TryCatchStatementContext ctx)`
    `` | `ClassNode` | `visitType(TypeContext ctx)`
    `` | `GenericsType` | `visitTypeArgument(TypeArgumentContext ctx)`
    `` | `GenericsType[]` | `visitTypeArguments(TypeArgumentsContext ctx)`
    `` | `GenericsType[]` | `visitTypeArgumentsOrDiamond(TypeArgumentsOrDiamondContext ctx)`
    `` | `ClassNode[]` | `visitTypeBound(TypeBoundContext ctx)`
    `` | `ClassNode` | `visitTypeDeclaration(TypeDeclarationContext ctx)`
    `` | `ClassNode[]` | `visitTypeList(TypeListContext ctx)`
    `` | `VariableExpression` | `visitTypeNamePair(TypeNamePairContext ctx)`
    `` | `List<Expression>` | `visitTypeNamePairs(TypeNamePairsContext ctx)`
    `` | `GenericsType` | `visitTypeParameter(TypeParameterContext ctx)`
    `` | `GenericsType[]` | `visitTypeParameters(TypeParametersContext ctx)`
    `` | `Expression` | `visitUnaryAddExprAlt(UnaryAddExprAltContext ctx)`
    `` | `Expression` | `visitUnaryNotExprAlt(UnaryNotExprAltContext ctx)`
    `` | `AstBuilder.DeclarationListStatement` | `visitVariableDeclaration(VariableDeclarationContext ctx)`
    `` | `DeclarationExpression` | `visitVariableDeclarator(VariableDeclaratorContext ctx)`
    `` | `VariableExpression` | `visitVariableDeclaratorId(VariableDeclaratorIdContext ctx)`
    `` | `List<DeclarationExpression>` | `visitVariableDeclarators(VariableDeclaratorsContext ctx)`
    `` | `Expression` | `visitVariableInitializer(VariableInitializerContext ctx)`
    `` | `List<Expression>` | `visitVariableInitializers(VariableInitializersContext ctx)`
    `` | `ModifierNode` | `visitVariableModifier(VariableModifierContext ctx)`
    `` | `List<ModifierNode>` | `visitVariableModifiers(VariableModifiersContext ctx)`
    `` | `List<ModifierNode>` | `visitVariableModifiersOpt(VariableModifiersOptContext ctx)`
    `` | `TupleExpression` | `visitVariableNames(VariableNamesContext ctx)`
    `` | `WhileStatement` | `visitWhileStmtAlt(WhileStmtAltContext ctx)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class GroovyParserBaseVisitor` | `visitAdditiveExprAlt, visitAndExprAlt, visitAnnotatedQualifiedClassName, visitAnnotation, visitAnnotationName, visitAnnotationsOpt, visitAnonymousInnerClassDeclaration, visitArguments, visitArrayInitializer, visitAssertStatement, visitAssertStmtAlt, visitAssignmentExprAlt, visitBlock, visitBlockStatement, visitBlockStatements, visitBlockStatementsOpt, visitBlockStmtAlt, visitBooleanLiteralAlt, visitBreakStatement, visitBreakStmtAlt, visitBuiltInType, visitBuiltInTypePrmrAlt, visitCastExprAlt, visitCastParExpression, visitCatchClause, visitCatchType, visitClassBody, visitClassBodyDeclaration, visitClassDeclaration, visitClassName, visitClassOrInterfaceModifier, visitClassOrInterfaceModifiers, visitClassOrInterfaceModifiersOpt, visitClassOrInterfaceType, visitClassicalForControl, visitClosure, visitClosureOrLambdaExpression, visitClosureOrLambdaExpressionPrmrAlt, visitCommandArgument, visitCommandExprAlt, visitCommandExpression, visitCompilationUnit, visitConditionalExprAlt, visitConditionalStatement, visitConditionalStmtAlt, visitContinueStatement, visitContinueStmtAlt, visitCreatedName, visitCreator, visitDim, visitDoWhileStmtAlt, visitDynamicMemberName, visitElementValue, visitElementValueArrayInitializer, visitElementValuePair, visitElementValuePairName, visitElementValuePairs, visitElementValues, visitEmptyDims, visitEmptyDimsOpt, visitEmptyStmtAlt, visitEnhancedArgumentListElement, visitEnhancedArgumentListInPar, visitEnhancedForControl, visitEnhancedStatementExpression, visitEnumConstant, visitEnumConstants, visitEqualityExprAlt, visitExclusiveOrExprAlt, visitExpression, visitExpressionInPar, visitExpressionList, visitExpressionListElement, visitExpressionStmtAlt, visitFieldDeclaration, visitFinallyBlock, visitFloatingPointLiteralAlt, visitForControl, visitForInit, visitForStmtAlt, visitForUpdate, visitFormalParameter, visitFormalParameterList, visitFormalParameters, visitGstring, visitGstringPath, visitGstringPrmrAlt, visitGstringValue, visitIdentifier, visitIdentifierPrmrAlt, visitIfElseStatement, visitImportDeclaration, visitInclusiveOrExprAlt, visitIndexPropertyArgs, visitIntegerLiteralAlt, visitKeywords, visitLabeledStmtAlt, visitLambdaBody, visitList, visitListPrmrAlt, visitLiteral, visitLiteralPrmrAlt, visitLocalVariableDeclaration, visitLocalVariableDeclarationStmtAlt, visitLogicalAndExprAlt, visitLogicalOrExprAlt, visitLoopStatement, visitLoopStmtAlt, visitMap, visitMapEntry, visitMapEntryLabel, visitMapEntryList, visitMapPrmrAlt, visitMemberDeclaration, visitMethodBody, visitMethodDeclaration, visitMethodDeclarationStmtAlt, visitMethodName, visitModifier, visitModifiers, visitModifiersOpt, visitMultipleAssignmentExprAlt, visitMultiplicativeExprAlt, visitNamePart, visitNamedPropertyArgs, visitNewPrmrAlt, visitNls, visitNonWildcardTypeArguments, visitNullLiteralAlt, visitPackageDeclaration, visitParExpression, visitParenPrmrAlt, visitPathElement, visitPathExpression, visitPostfixExprAlt, visitPostfixExpression, visitPowerExprAlt, visitPrimary, visitPrimitiveType, visitQualifiedClassName, visitQualifiedClassNameList, visitQualifiedName, visitQualifiedNameElement, visitQualifiedNameElements, visitQualifiedStandardClassName, visitRegexExprAlt, visitRelationalExprAlt, visitResource, visitResourceList, visitResources, visitReturnStmtAlt, visitReturnType, visitRparen, visitScriptStatement, visitScriptStatements, visitSep, visitShiftExprAlt, visitStandardLambdaExpression, visitStandardLambdaParameters, visitStatement, visitStatementExpression, visitStringLiteral, visitStringLiteralAlt, visitSuperPrmrAlt, visitSwitchBlockStatementGroup, visitSwitchLabel, visitSwitchStatement, visitSynchronizedStmtAlt, visitThisFormalParameter, visitThisPrmrAlt, visitThrowStmtAlt, visitTryCatchStatement, visitTryCatchStmtAlt, visitType, visitTypeArgument, visitTypeArguments, visitTypeArgumentsOrDiamond, visitTypeBound, visitTypeDeclaration, visitTypeList, visitTypeNamePair, visitTypeNamePairs, visitTypeParameter, visitTypeParameters, visitUnaryAddExprAlt, visitUnaryNotExprAlt, visitVariableDeclaration, visitVariableDeclarator, visitVariableDeclaratorId, visitVariableDeclarators, visitVariableInitializer, visitVariableInitializers, visitVariableModifier, visitVariableModifiers, visitVariableModifiersOpt, visitVariableNames, visitWhileStmtAlt`

- - ### Constructor Detail

    - #### public AstBuilder(SourceUnit sourceUnit, boolean groovydocEnabled, boolean runtimeGroovydocEnabled)

  - ### Method Detail

    - #### public BlockStatement appendStatementsToBlockStatement(BlockStatement bs, Statement statements)

    - #### public ModuleNode buildAST()

    - #### @Override public void syntaxError(Recognizer recognizer, Object offendingSymbol, int line, int charPositionInLine, String msg, RecognitionException e)

    - #### @Override public Object visit(ParseTree tree)

      Visit tree safely, no NPE occurred when the tree is null.

      Parameters:
        `tree` - an AST node
      Returns:
        the visiting result

    - #### @Override public BinaryExpression visitAdditiveExprAlt(AdditiveExprAltContext ctx)

    - #### @Override public BinaryExpression visitAndExprAlt(AndExprAltContext ctx)

    - #### @Override public ClassNode visitAnnotatedQualifiedClassName(AnnotatedQualifiedClassNameContext ctx)

    - #### @Override public AnnotationNode visitAnnotation(AnnotationContext ctx)

    - #### @Override public String visitAnnotationName(AnnotationNameContext ctx)

    - #### @Override public List<AnnotationNode> visitAnnotationsOpt(AnnotationsOptContext ctx)

    - #### @Override public InnerClassNode visitAnonymousInnerClassDeclaration(AnonymousInnerClassDeclarationContext ctx)

    - #### @Override public Expression visitArguments(ArgumentsContext ctx)

    - #### @Override public List<Expression> visitArrayInitializer(ArrayInitializerContext ctx)

    - #### @Override public AssertStatement visitAssertStatement(AssertStatementContext ctx)

    - #### @Override public BinaryExpression visitAssignmentExprAlt(AssignmentExprAltContext ctx)

    - #### @Override public Statement visitBlock(BlockContext ctx)

    - #### @Override public Statement visitBlockStatement(BlockStatementContext ctx)

    - #### @Override public BlockStatement visitBlockStatements(BlockStatementsContext ctx)

    - #### @Override public BlockStatement visitBlockStatementsOpt(BlockStatementsOptContext ctx)

    - #### @Override public ConstantExpression visitBooleanLiteralAlt(BooleanLiteralAltContext ctx)

    - #### @Override public BreakStatement visitBreakStatement(BreakStatementContext ctx)

    - #### @Override public VariableExpression visitBuiltInType(BuiltInTypeContext ctx)

    - #### @Override public CastExpression visitCastExprAlt(CastExprAltContext ctx)

    - #### @Override public ClassNode visitCastParExpression(CastParExpressionContext ctx)

    - #### @Override public List<CatchStatement> visitCatchClause(CatchClauseContext ctx)

      Multi-catch(1..*) clause will be unpacked to several normal catch clauses, so the return type is List

      Parameters:
        `ctx` - the parse tree
      Returns:
        a list of CatchStatement instances

    - #### @Override public List<ClassNode> visitCatchType(CatchTypeContext ctx)

    - #### @Override public Void visitClassBody(ClassBodyContext ctx)

    - #### @Override public Void visitClassBodyDeclaration(ClassBodyDeclarationContext ctx)

    - #### @Override public ClassNode visitClassDeclaration(ClassDeclarationContext ctx)

    - #### @Override public String visitClassName(ClassNameContext ctx)

    - #### @Override public ModifierNode visitClassOrInterfaceModifier(ClassOrInterfaceModifierContext ctx)

    - #### @Override public List<ModifierNode> visitClassOrInterfaceModifiers(ClassOrInterfaceModifiersContext ctx)

    - #### @Override public List<ModifierNode> visitClassOrInterfaceModifiersOpt(ClassOrInterfaceModifiersOptContext ctx)

    - #### @Override public ClassNode visitClassOrInterfaceType(ClassOrInterfaceTypeContext ctx)

    - #### @Override public Tuple2<Parameter, Expression> visitClassicalForControl(ClassicalForControlContext ctx)

    - #### @Override public ClosureExpression visitClosure(ClosureContext ctx)

    - #### @Override public ClosureExpression visitClosureOrLambdaExpression(ClosureOrLambdaExpressionContext ctx)

    - #### @Override public Expression visitCommandArgument(CommandArgumentContext ctx)

    - #### @Override public ExpressionStatement visitCommandExprAlt(CommandExprAltContext ctx)

    - #### @Override public Expression visitCommandExpression(CommandExpressionContext ctx)

    - #### @Override public ModuleNode visitCompilationUnit(CompilationUnitContext ctx)

    - #### @Override public Expression visitConditionalExprAlt(ConditionalExprAltContext ctx)

    - #### @Override public Statement visitConditionalStatement(ConditionalStatementContext ctx)

    - #### @Override public ContinueStatement visitContinueStatement(ContinueStatementContext ctx)

    - #### @Override public ClassNode visitCreatedName(CreatedNameContext ctx)

    - #### @Override public Expression visitCreator(CreatorContext ctx)

    - #### @Override public Tuple3<Expression, List<AnnotationNode>, TerminalNode> visitDim(DimContext ctx)

    - #### @Override public DoWhileStatement visitDoWhileStmtAlt(DoWhileStmtAltContext ctx)

    - #### @Override public Expression visitDynamicMemberName(DynamicMemberNameContext ctx)

    - #### @Override public Expression visitElementValue(ElementValueContext ctx)

    - #### @Override public ListExpression visitElementValueArrayInitializer(ElementValueArrayInitializerContext ctx)

    - #### @Override public Tuple2<String, Expression> visitElementValuePair(ElementValuePairContext ctx)

    - #### @Override public Map<String, Expression> visitElementValuePairs(ElementValuePairsContext ctx)

    - #### @Override public List<Tuple2<String, Expression>> visitElementValues(ElementValuesContext ctx)

    - #### @Override public List<List<AnnotationNode>> visitEmptyDims(EmptyDimsContext ctx)

    - #### @Override public List<List<AnnotationNode>> visitEmptyDimsOpt(EmptyDimsOptContext ctx)

    - #### @Override public Expression visitEnhancedArgumentListElement(EnhancedArgumentListElementContext ctx)

    - #### @Override public Expression visitEnhancedArgumentListInPar(EnhancedArgumentListInParContext ctx)

    - #### @Override public Tuple2<Parameter, Expression> visitEnhancedForControl(EnhancedForControlContext ctx)

    - #### @Override public Expression visitEnhancedStatementExpression(EnhancedStatementExpressionContext ctx)

    - #### @Override public FieldNode visitEnumConstant(EnumConstantContext ctx)

    - #### @Override public List<FieldNode> visitEnumConstants(EnumConstantsContext ctx)

    - #### @Override public BinaryExpression visitEqualityExprAlt(EqualityExprAltContext ctx)

    - #### @Override public BinaryExpression visitExclusiveOrExprAlt(ExclusiveOrExprAltContext ctx)

    - #### @Override public Expression visitExpressionInPar(ExpressionInParContext ctx)

    - #### @Override public List<Expression> visitExpressionList(ExpressionListContext ctx)

    - #### @Override public Expression visitExpressionListElement(ExpressionListElementContext ctx)

    - #### @Override public Void visitFieldDeclaration(FieldDeclarationContext ctx)

    - #### @Override public Statement visitFinallyBlock(FinallyBlockContext ctx)

    - #### @Override public ConstantExpression visitFloatingPointLiteralAlt(FloatingPointLiteralAltContext ctx)

    - #### @Override public Tuple2<Parameter, Expression> visitForControl(ForControlContext ctx)

    - #### @Override public Expression visitForInit(ForInitContext ctx)

    - #### @Override public ForStatement visitForStmtAlt(ForStmtAltContext ctx)

    - #### @Override public Expression visitForUpdate(ForUpdateContext ctx)

    - #### @Override public Parameter visitFormalParameter(FormalParameterContext ctx)

    - #### @Override public Parameter[] visitFormalParameterList(FormalParameterListContext ctx)

    - #### @Override public Parameter[] visitFormalParameters(FormalParametersContext ctx)

    - #### @Override public GStringExpression visitGstring(GstringContext ctx)

    - #### @Override public Expression visitGstringPath(GstringPathContext ctx)

    - #### @Override public Expression visitGstringValue(GstringValueContext ctx)

    - #### @Override public String visitIdentifier(IdentifierContext ctx)

    - #### @Override public Expression visitIdentifierPrmrAlt(IdentifierPrmrAltContext ctx)

    - #### @Override public IfStatement visitIfElseStatement(IfElseStatementContext ctx)

    - #### @Override public ImportNode visitImportDeclaration(ImportDeclarationContext ctx)

    - #### @Override public BinaryExpression visitInclusiveOrExprAlt(InclusiveOrExprAltContext ctx)

    - #### @Override public Tuple2<Token, Expression> visitIndexPropertyArgs(IndexPropertyArgsContext ctx)

    - #### @Override public ConstantExpression visitIntegerLiteralAlt(IntegerLiteralAltContext ctx)

    - #### @Override public ConstantExpression visitKeywords(KeywordsContext ctx)

    - #### @Override public Statement visitLabeledStmtAlt(LabeledStmtAltContext ctx)

    - #### @Override public Statement visitLambdaBody(LambdaBodyContext ctx)

    - #### @Override public ListExpression visitList(ListContext ctx)

    - #### @Override public AstBuilder.DeclarationListStatement visitLocalVariableDeclaration(LocalVariableDeclarationContext ctx)

    - #### @Override public BinaryExpression visitLogicalAndExprAlt(LogicalAndExprAltContext ctx)

    - #### @Override public BinaryExpression visitLogicalOrExprAlt(LogicalOrExprAltContext ctx)

    - #### @Override public Statement visitLoopStmtAlt(LoopStmtAltContext ctx)

    - #### @Override public MapExpression visitMap(MapContext ctx)

    - #### @Override public MapEntryExpression visitMapEntry(MapEntryContext ctx)

    - #### @Override public Expression visitMapEntryLabel(MapEntryLabelContext ctx)

    - #### @Override public List<MapEntryExpression> visitMapEntryList(MapEntryListContext ctx)

    - #### @Override public Void visitMemberDeclaration(MemberDeclarationContext ctx)

    - #### @Override public Statement visitMethodBody(MethodBodyContext ctx)

    - #### @Override public MethodNode visitMethodDeclaration(MethodDeclarationContext ctx)

    - #### @Override public String visitMethodName(MethodNameContext ctx)

    - #### @Override public ModifierNode visitModifier(ModifierContext ctx)

    - #### @Override public List<ModifierNode> visitModifiers(ModifiersContext ctx)

    - #### @Override public List<ModifierNode> visitModifiersOpt(ModifiersOptContext ctx)

    - #### @Override public BinaryExpression visitMultipleAssignmentExprAlt(MultipleAssignmentExprAltContext ctx)

    - #### @Override public BinaryExpression visitMultiplicativeExprAlt(MultiplicativeExprAltContext ctx)

    - #### @Override public Expression visitNamePart(NamePartContext ctx)

    - #### @Override public List<MapEntryExpression> visitNamedPropertyArgs(NamedPropertyArgsContext ctx)

    - #### @Override public Expression visitNewPrmrAlt(NewPrmrAltContext ctx)

    - #### @Override public GenericsType[] visitNonWildcardTypeArguments(NonWildcardTypeArgumentsContext ctx)

    - #### @Override public ConstantExpression visitNullLiteralAlt(NullLiteralAltContext ctx)

    - #### @Override public PackageNode visitPackageDeclaration(PackageDeclarationContext ctx)

    - #### @Override public Expression visitParExpression(ParExpressionContext ctx)

    - #### @Override public Expression visitPathElement(PathElementContext ctx)

    - #### @Override public Expression visitPathExpression(PathExpressionContext ctx)

    - #### @Override public Expression visitPostfixExpression(PostfixExpressionContext ctx)

    - #### @Override public BinaryExpression visitPowerExprAlt(PowerExprAltContext ctx)

    - #### @Override public ClassNode visitPrimitiveType(PrimitiveTypeContext ctx)

    - #### @Override public ClassNode visitQualifiedClassName(QualifiedClassNameContext ctx)

    - #### @Override public ClassNode[] visitQualifiedClassNameList(QualifiedClassNameListContext ctx)

    - #### @Override public String visitQualifiedName(QualifiedNameContext ctx)

    - #### @Override public ClassNode visitQualifiedStandardClassName(QualifiedStandardClassNameContext ctx)

    - #### @Override public BinaryExpression visitRegexExprAlt(RegexExprAltContext ctx)

    - #### @Override public Expression visitRelationalExprAlt(RelationalExprAltContext ctx)

    - #### @Override public ExpressionStatement visitResource(ResourceContext ctx)

    - #### @Override public List<ExpressionStatement> visitResourceList(ResourceListContext ctx)

    - #### @Override public List<ExpressionStatement> visitResources(ResourcesContext ctx)

    - #### @Override public ReturnStatement visitReturnStmtAlt(ReturnStmtAltContext ctx)

    - #### @Override public ClassNode visitReturnType(ReturnTypeContext ctx)

    - #### @Override public List<ASTNode> visitScriptStatements(ScriptStatementsContext ctx)

    - #### @Override public Expression visitShiftExprAlt(ShiftExprAltContext ctx)

    - #### @Override public LambdaExpression visitStandardLambdaExpression(StandardLambdaExpressionContext ctx)

    - #### @Override public Parameter[] visitStandardLambdaParameters(StandardLambdaParametersContext ctx)

    - #### @Override public ConstantExpression visitStringLiteral(StringLiteralContext ctx)

    - #### @Override public VariableExpression visitSuperPrmrAlt(SuperPrmrAltContext ctx)

    - #### @Override @SuppressWarnings("unchecked") public List<Statement> visitSwitchBlockStatementGroup(SwitchBlockStatementGroupContext ctx)

    - #### @Override public Tuple2<Token, Expression> visitSwitchLabel(SwitchLabelContext ctx)

    - #### @Override public SwitchStatement visitSwitchStatement(SwitchStatementContext ctx)

    - #### @Override public SynchronizedStatement visitSynchronizedStmtAlt(SynchronizedStmtAltContext ctx)

    - #### @Override public Parameter visitThisFormalParameter(ThisFormalParameterContext ctx)

    - #### @Override public VariableExpression visitThisPrmrAlt(ThisPrmrAltContext ctx)

    - #### @Override public ThrowStatement visitThrowStmtAlt(ThrowStmtAltContext ctx)

    - #### @Override public Statement visitTryCatchStatement(TryCatchStatementContext ctx)

    - #### @Override public ClassNode visitType(TypeContext ctx)

    - #### @Override public GenericsType visitTypeArgument(TypeArgumentContext ctx)

    - #### @Override public GenericsType[] visitTypeArguments(TypeArgumentsContext ctx)

    - #### @Override public GenericsType[] visitTypeArgumentsOrDiamond(TypeArgumentsOrDiamondContext ctx)

    - #### @Override public ClassNode[] visitTypeBound(TypeBoundContext ctx)

    - #### @Override public ClassNode visitTypeDeclaration(TypeDeclarationContext ctx)

    - #### @Override public ClassNode[] visitTypeList(TypeListContext ctx)

    - #### @Override public VariableExpression visitTypeNamePair(TypeNamePairContext ctx)

    - #### @Override public List<Expression> visitTypeNamePairs(TypeNamePairsContext ctx)

    - #### @Override public GenericsType visitTypeParameter(TypeParameterContext ctx)

    - #### @Override public GenericsType[] visitTypeParameters(TypeParametersContext ctx)

    - #### @Override public Expression visitUnaryAddExprAlt(UnaryAddExprAltContext ctx)

    - #### @Override public Expression visitUnaryNotExprAlt(UnaryNotExprAltContext ctx)

    - #### @Override public AstBuilder.DeclarationListStatement visitVariableDeclaration(VariableDeclarationContext ctx)

    - #### @Override public DeclarationExpression visitVariableDeclarator(VariableDeclaratorContext ctx)

    - #### @Override public VariableExpression visitVariableDeclaratorId(VariableDeclaratorIdContext ctx)

    - #### @Override public List<DeclarationExpression> visitVariableDeclarators(VariableDeclaratorsContext ctx)

    - #### @Override public Expression visitVariableInitializer(VariableInitializerContext ctx)

    - #### @Override public List<Expression> visitVariableInitializers(VariableInitializersContext ctx)

    - #### @Override public ModifierNode visitVariableModifier(VariableModifierContext ctx)

    - #### @Override public List<ModifierNode> visitVariableModifiers(VariableModifiersContext ctx)

    - #### @Override public List<ModifierNode> visitVariableModifiersOpt(VariableModifiersOptContext ctx)

    - #### @Override public TupleExpression visitVariableNames(VariableNamesContext ctx)

    - #### @Override public WhileStatement visitWhileStmtAlt(WhileStmtAltContext ctx)